#ifndef ZERO_H
#define ZERO_H

static inline int printk(const char *format, ...)
{
#if DBG
 extern char printk_buf[1024];
 va_list args;
 va_start(args, format);
 int cw=_vsnprintf(printk_buf, sizeof(printk_buf), format, args);
 DbgPrint("zero: %s", printk_buf);
 va_end(args);
 return cw;
#else
 return 0;
#endif
}

class KDevice : private DEVICE_OBJECT
{
public:
 NTSTATUS ConstructorStatus;
private:
 UNICODE_STRING SymLink;
public:
 static NTSTATUS KDevice::Dispatch(PDEVICE_OBJECT DeviceObject, PIRP Irp);

 static BOOLEAN FastIoRead(IN PFILE_OBJECT FileObject,
                           IN PLARGE_INTEGER FileOffset,
                           IN ULONG Length,
                           IN BOOLEAN Wait,
                           IN ULONG LockKey,
                           OUT PVOID Buffer,
                           OUT PIO_STATUS_BLOCK IoStatus,
                           IN PDEVICE_OBJECT DeviceObject);

 static BOOLEAN FastIoWrite(IN PFILE_OBJECT FileObject,
                            IN PLARGE_INTEGER FileOffset,
                            IN ULONG Length,
                            IN BOOLEAN Wait,
                            IN ULONG LockKey,
                            OUT PVOID Buffer,
                            OUT PIO_STATUS_BLOCK IoStatus,
                            IN PDEVICE_OBJECT DeviceObject);

 void *operator new(size_t Size, PDRIVER_OBJECT DriverObject,
  PCWSTR DeviceName, PCWSTR SymLinkName);
 void operator delete(void *){}
 KDevice(){}
 ~KDevice();

protected:
 NTSTATUS Create(PIRP Irp);
 NTSTATUS Close(PIRP Irp);
 NTSTATUS Read(PIRP Irp);
 NTSTATUS Write(PIRP Irp);
 NTSTATUS Cleanup(PIRP Irp);
 NTSTATUS QueryInformation(PIRP Irp);
 NTSTATUS SetInformation(PIRP Irp);

 BOOLEAN FastIoRead(IN PFILE_OBJECT FileObject,
                    IN PLARGE_INTEGER FileOffset,
                    IN ULONG Length,
                    IN BOOLEAN Wait,
                    IN ULONG LockKey,
                    OUT PVOID Buffer,
                    OUT PIO_STATUS_BLOCK IoStatus);

 BOOLEAN FastIoWrite(IN PFILE_OBJECT FileObject,
                     IN PLARGE_INTEGER FileOffset,
                     IN ULONG Length,
                     IN BOOLEAN Wait,
                     IN ULONG LockKey,
                     OUT PVOID Buffer,
                     OUT PIO_STATUS_BLOCK IoStatus);

private:
 NTSTATUS ReadNormal(PIRP Irp);
};

class KDriver
{
private:
 PDRIVER_OBJECT DriverObject;
 KDevice *Device;
 NTSTATUS ConstructorStatus;
public:
 KDriver(PDRIVER_OBJECT SysDo);
 ~KDriver()
 {
  delete Device;
  delete DriverObject->FastIoDispatch;
  DriverObject->FastIoDispatch=0;
 }
private:
 static NTSTATUS Entry(IN PDRIVER_OBJECT DriverObject,IN PUNICODE_STRING RegistryPath);
 static void Unload(IN PDRIVER_OBJECT DriverObject);
};
#endif
