.SUFFIXES:
.SUFFIXES: .c .cpp .rc .res .obj .sys

RELEASE=1

CXXFLAGS_COMMON= -nologo -c -GX- -GR- -Gz -GF -Gy -D_X86_ \
                 -D_WIN32_WINNT=0x0400 -Iinc -W3 -I$(BASEDIR2K)\src\filesys\inc -I$(BASEDIR)\inc

CXXFLAGS_DBG= $(CXXFLAGS_COMMON) -Od -Oy- -Zi -DDBG=1
CXXFLAGS_NDBG= $(CXXFLAGS_COMMON) -O3 -Og -Os -Ob2 -DDBG=0

!if $(RELEASE) == 1
CXXFLAGS=$(CXXFLAGS_NDBG)
!else
CXXFLAGS=$(CXXFLAGS_DBG)
!endif

LINKFLAGS_COMMON= -nologo -nodefaultlib \
           -entry:"?Entry@KDriver@@CGJPAU_DRIVER_OBJECT@@PAU_UNICODE_STRING@@@Z" \
           -driver -release -subsystem:native,4.0 \
           -base:0x10000 \
           -version:4.00 -osversion:4.00 -opt:ref -opt:icf -opt:nowin98 \
           -merge:.data1=.data \
           -libpath:$(BASEDIR)\Lib\i386\Free

LINKFLAGS_DBG=$(LINKFLAGS_COMMON) -debug
LINKFLAGS_NDBG=$(LINKFLAGS_COMMON)

!if $(RELEASE) == 1
LINKFLAGS=$(LINKFLAGS_NDBG)
!else
LINKFLAGS=$(LINKFLAGS_DBG)
!endif

LIBS=ntoskrnl.lib

all : zero.sys

clean:
	del -q *.obj *.pdb *.sys *.res

.cpp.obj::
	cl $(CXXFLAGS) $<

zero.sys:
	link $(LINKFLAGS) $? $(LIBS) -out:$@

.rc.res:
	rc -fo$@ $<

.res.obj:
	cvtres -nologo -machine:x86 -out:$@ $<

zero.sys: driver.obj device.obj create.obj close.obj read.obj write.obj \
          libcpp.obj cleanup.obj queryinfo.obj setinfo.obj zero.res
driver.obj: driver.cpp zero.h prefix.h
device.obj: device.cpp zero.h prefix.h
create.obj: create.cpp zero.h prefix.h
cleanup.obj: cleanup.cpp zero.h prefix.h
close.obj: close.cpp zero.h prefix.h
read.obj: read.cpp zero.h prefix.h
write.obj: write.cpp zero.h prefix.h
queryinfo.obj: queryinfo.cpp zero.h prefix.h
setinfo.obj: setinfo.cpp zero.h prefix.h
